#include "io.h"

// #include <stdio.h>
// #include <unistd.h>

/* Test data */
char data[] = "The Cathedral and the Bazaar\n\n" \
"Linux is subversive. Who would have thought even five years ago (1991)" \
"that a world-class operating system could coalesce as if by magic out" \
"of part-time hacking by several thousand developers scattered all over" \
"the planet, connected only by the tenuous strands of the Internet? -- ESR\n";

int getdata(void *buf, int count) {

  static char* dataptr = data;
  int i;

  for (i=0; i<count; i++) {
    *((unsigned char*)buf + i) = *dataptr++;
    if (dataptr-data >= sizeof(data)) break;
  }

  return i;
}

/*
void encodeAndCopy(int codeblock, int datablock, int N){

  int 
    inbuffer[datablock],      // data to be read and encoded
    // outbuffer[codeblock],     // encoded data to be written
    wanted,                   // count of bytes to be read
    count;                    // count of bytes actually read

  char *inptr;                // pointer to next free in inbuffer

  do {

    // read a block of test data, encode it, and write it to stdout
    inptr = (char*)inbuffer; 
    wanted = datablock*4;

    while (wanted && 0 < (count = getdata(inptr, wanted))) {
      wanted -= count; inptr += count;
    }

    if (count > 0) {
      // the ordinary case: a whole block has been read
      write(IO_FD3, inbuffer, datablock*4);
      continue;
    } 
    
    if (count == 0) {

      // end-of file has occurred

      // the last word written should tell how many
      // trailing bytes have been added
      if (wanted > 3) {
	count = wanted-4;
	while (count--) *(inptr++) = 0;
	inbuffer[datablock-1] = wanted;
	write(IO_FD3,inbuffer,datablock*4);
	break;
      }

      // not enough room for the count
      // so a new, otherwise empty block must be generated
      count = wanted; 
      while (count--) *(inptr++) = 0;
      write(IO_FD3,inbuffer,datablock*4);

      inbuffer[datablock-1] = wanted+datablock*4;
      count = datablock-2;
      while (count) inbuffer[count--] = 0;
      write(IO_FD3, inbuffer, datablock*4);
      break;
    }

  } while (1);
  // All done
}
*/

int main(void) 
{
  /*
  int
    N,                // The number of auxiliary bit in a Hamming code.
    codeblock,        // The length of an encoded block
    datablock;        // The length of a block of data
  */

  int i;
  int 
    inbuffer[26],              // data to be read and encoded
    // outbuffer[codeblock],   // encoded data to be written
    wanted,                    // count of bytes to be read
    count;                     // count of bytes actually read

  char *inptr;                 // pointer to next free in inbuffer
  static char* dataptr = data;

  inptr = (char*)inbuffer; 
  wanted = 26*sizeof(int);

  // while (wanted && 0 < (count = getdata(inptr, wanted))) {
  //   wanted -= count; inptr += count;
  // }
  getdata(inptr, wanted);
  // printf("%s", (char*) inbuffer);

  write(IO_FD3, (char*)inbuffer, 54);

  /*
  for (i=0; i<count; i++) {
    *((unsigned char*)buf + i) = *dataptr++;
    write(IO_FD3, inbuffer, datablock*4);
    if (dataptr-data >= sizeof(data)) break;
  }


  N = 5;

  codeblock = (1<<N) - 1;
  datablock = codeblock - N;
  encodeAndCopy(codeblock, datablock, N);
  */
  return 0;
}
